﻿Option Strict On

Imports System.Drawing.Imaging.ImageFormat
Imports System.IO

Public Class Form1
    Dim ControlledItems As New Dictionary(Of CheckBox, Control)
    Private IsLoggedIn As Boolean
    Private PicFile As String = ""


    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim controlledItem As Control, cb As CheckBox
        For Each cb In VisibleItemsGroupBox.Controls
            If TypeOf cb Is CheckBox Then
                Select Case cb.Text
                    Case "Show Avatar"
                        controlledItem = PictureBox2
                    Case "Show Name"
                        controlledItem = Label3
                    Case "Show Title"
                        controlledItem = Label4
                    Case "Show Gems"
                        controlledItem = ReputationGemsPanel
                    Case "Show Join Date"
                        controlledItem = Label5
                    Case "Show Total Post Count"
                        controlledItem = Label8
                    Case "Show Avg Post Count"
                        controlledItem = Label7
                    Case Else
                        controlledItem = Nothing
                End Select
                ControlledItems.Add(cb, controlledItem)
                AddHandler cb.CheckedChanged, AddressOf CheckBoxes_CheckedChanged
            End If
        Next
    End Sub

    '~~> Login Button
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        If TextBox1.Text = "" Then
            MessageBox.Show("Please enter the username", "Username Missing")
            TextBox1.Select()
            Exit Sub
        End If

        If TextBox2.Text = "" Then
            MessageBox.Show("Please enter the password", "Password Missing")
            TextBox2.Select()
            Exit Sub
        End If

        Button3.Enabled = False
        Label6.Visible = True
        Application.DoEvents()
        IsLoggedIn = False

        WebBrowser1.ScriptErrorsSuppressed = True
        WebBrowser1.Navigate("http://www.vbforums.com/memberlist.php")
        Application.DoEvents()
    End Sub

    Private Sub WebBrowser1_DocumentCompleted(ByVal sender As System.Object, ByVal e As System.Windows.Forms.WebBrowserDocumentCompletedEventArgs) Handles WebBrowser1.DocumentCompleted
        Dim HTMLcode As String = WebBrowser1.Document.Body.InnerHtml
        Dim ihtml As String = ""
        Dim sUrl As String = ""
        Dim elem As HtmlElement

        If WebBrowser1.ReadyState <> WebBrowserReadyState.Complete Then Exit Sub

        If HTMLcode.Contains("The administrator may have required you to") Then
            elem = GetElementByAttribute("name", "vb_login_username", "input")
            elem.SetAttribute("value", TextBox1.Text)
            elem = GetElementByAttribute("name", "vb_login_password", "input")
            elem.SetAttribute("value", TextBox2.Text)
            elem = GetElementByAttribute("value", "Log in", "input")
            elem.InvokeMember("click")
            Return
        ElseIf HTMLcode.Contains("invalid username") Or HTMLcode.Contains("Wrong username") Then
            MessageBox.Show("Name or Password for VBForums is invalid! Check settings.", "Incorrect details", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Label6.Visible = False
            Button3.Enabled = True
            Return
        ElseIf HTMLcode.Contains("Search Members") Then
            IsLoggedIn = True
            elem = GetElementByClassName("welcomelink", "li")
            ihtml = elem.InnerHtml
            Dim uId As String = GetTextBetween(ihtml, "?", "-")
            If Not uId = String.Empty Then
                sUrl = String.Format("http://www.vbforums.com/member.php?{0}-{1}&tab=aboutme#aboutme", uId, TextBox1.Text)
                WebBrowser1.Navigate(sUrl)
            End If
        ElseIf HTMLcode.Contains("Basic Information") Then
            UpdateUserInformation()
            ShowHideControls()
            Label6.Visible = False
        End If
    End Sub

    Private Function GetElementByClassName(ByVal className As String, Optional ByVal tagName As String = "", Optional ByVal parentElement As HtmlElement = Nothing) As HtmlElement
        Return GetElementByAttribute("className", className, tagName, parentElement)
    End Function

    Private Function GetElementsByClassName(ByVal className As String, Optional ByVal tagName As String = "", Optional ByVal parentElement As HtmlElement = Nothing) As HtmlElement()
        Return GetElementsByAttribute("className", className, tagName, parentElement)
    End Function

    Private Function GetElementByAttribute(ByVal attributeName As String, ByVal attributeValue As String, Optional ByVal tagName As String = "", Optional ByVal parentElement As HtmlElement = Nothing) As HtmlElement
        If parentElement = Nothing Then parentElement = WebBrowser1.Document.Body
        Dim elements As HtmlElementCollection
        If String.IsNullOrEmpty(tagName) Then
            elements = WebBrowser1.Document.All
        Else
            elements = WebBrowser1.Document.GetElementsByTagName(tagName)
        End If
        For Each elem As HtmlElement In elements
            If attributeName = "InnerText" AndAlso elem.InnerText.Trim = attributeValue Then
                Return elem
            ElseIf elem.GetAttribute(attributeName) = attributeValue Then
                Return elem
            End If
        Next
        Return Nothing
    End Function

    Private Function GetElementsByAttribute(ByVal attributeName As String, ByVal attributeValue As String, Optional ByVal tagName As String = "", Optional ByVal parentElement As HtmlElement = Nothing) As HtmlElement()
        Dim foundElements As New List(Of HtmlElement)
        If parentElement = Nothing Then parentElement = WebBrowser1.Document.Body
        Dim elements As HtmlElementCollection
        If String.IsNullOrEmpty(tagName) Then
            elements = WebBrowser1.Document.All
        Else
            elements = WebBrowser1.Document.GetElementsByTagName(tagName)
        End If
        For Each elem As HtmlElement In elements
            If attributeName = "InnerText" AndAlso elem.InnerText.Trim = attributeValue Then
                foundElements.Add(elem)
            ElseIf elem.GetAttribute(attributeName) = attributeValue Then
                foundElements.Add(elem)
            End If
        Next
        Return foundElements.ToArray
    End Function

    '~~> Enable all relevant controls post login
    Private Sub ShowHideControls()
        Me.TextBox1.Enabled = False : Me.TextBox2.Enabled = False
        Me.Button3.Enabled = False

        Label9.Text = "Welcome " & Me.TextBox1.Text & ", You may now select different options below to create the flair"
        Label9.Visible = True

        VisibleItemsGroupBox.Visible = True
        Panel1.Visible = True
        Me.Button2.Visible = True
    End Sub

    '~~> Function to get text between two strings
    Private Function GetTextBetween(ByVal MainTxt As String, ByVal StartTxt As String, ByVal EndTxt As String, Optional ByVal Occurance As Integer = 1) As String
        Dim txt As String = ""
        If Occurance < 1 Then Occurance = 1
        Try
            txt = Split(Split(MainTxt, StartTxt)(Occurance), EndTxt)(0)
        Catch
            Return ""
        End Try
        Return txt
    End Function

    '~~> Quit the App
    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Me.Close()
    End Sub

    '~~> Export Flair
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim saveFileDialog1 As New SaveFileDialog()
        saveFileDialog1.Filter = "JPeg Image|*.jpg|Bitmap Image|*.bmp|Gif Image|*.gif"
        saveFileDialog1.Title = "Save Image File as Bitmap"
        saveFileDialog1.ShowDialog()

        '~~> If the file name is not an empty string open it for saving.
        If saveFileDialog1.FileName <> "" Then
            '~~> Saves the Image via a FileStream created by the OpenFile method.
            Dim fs As FileStream = CType(saveFileDialog1.OpenFile(), System.IO.FileStream)
            Dim finalBmp As New Bitmap(Panel1.Width, Panel1.Height)
            Panel1.DrawToBitmap(finalBmp, Panel1.DisplayRectangle)
            '~~> Saves the Image in the appropriate ImageFormat based upon the  file type selected in the dialog box.
            Select Case saveFileDialog1.FilterIndex
                Case 1 : finalBmp.Save(fs, Jpeg)
                Case 2 : finalBmp.Save(fs, Bmp)
                Case 3 : finalBmp.Save(fs, Gif)
            End Select

            fs.Close()
        End If
    End Sub

    Private Sub CheckBoxes_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim cb As CheckBox = CType(sender, CheckBox)
        Dim controlledItem As Control = ControlledItems(cb)
        controlledItem.Visible = cb.Checked
    End Sub

    Private Sub UpdateUserInformation()
        Dim HTMLcode As String = WebBrowser1.Document.Body.InnerHtml
        Dim ihtml As String = ""
        Dim sUrl As String = ""
        Dim containerElem, elem As HtmlElement

        '~~> Download the thumbnail
        elem = GetElementByClassName("avatar", "dd")
        ihtml = elem.InnerHtml

        Dim picUrl As String = GetTextBetween(ihtml, "?", "thumb")

        If Not picUrl = String.Empty Then
            sUrl = "http://www.vbforums.com/image.php?" & picUrl & "thumb"

            Dim wc As New System.Net.WebClient
            PicFile = IO.Path.GetTempFileName
            wc.DownloadFile(sUrl, PicFile)
            PictureBox2.Image = New Bitmap(Image.FromFile(PicFile), 70, 70)
            Application.DoEvents()
        End If

        containerElem = WebBrowser1.Document.GetElementById("userinfo")
        Dim reputationImg() As HtmlElement = GetElementsByClassName("repimg", "img", containerElem)
        Dim lastLoc As Integer
        For Each elem In reputationImg
            Dim pb As New PictureBox
            pb.SizeMode = PictureBoxSizeMode.AutoSize
            Select Case IO.Path.GetFileNameWithoutExtension(elem.GetAttribute("src"))
                Case "reputation_pos"
                    pb.Image = My.Resources.Resource1.reputation_pos
                Case "reputation_neg"
                    pb.Image = My.Resources.Resource1.reputation_neg
                Case "reputation_off"
                    pb.Image = My.Resources.Resource1.reputation_off
                Case "reputation_balance"
                    pb.Image = My.Resources.Resource1.reputation_balance
                Case "reputation_highpos"
                    pb.Image = My.Resources.Resource1.reputation_highpos
            End Select
            ReputationGemsPanel.Controls.Add(pb)
            pb.Location = New Point(lastLoc, 0)
            lastLoc += pb.Width
        Next

        '~~> Username
        Label3.Text = TextBox1.Text

        '~~> Find User Title
        Label4.Text = GetElementByClassName("usertitle", "span").InnerText

        '~~> Find Join Date
        containerElem = WebBrowser1.Document.GetElementById("view-stats")
        elem = GetElementByAttribute("InnerText", "Join Date", "dt", containerElem).NextSibling
        Label5.Text = "Member Since: " & elem.InnerText

        '~~> Total Posts
        elem = GetElementByAttribute("InnerText", "Total Posts", "dt", containerElem).NextSibling
        Label8.Text = "Total Posts: " & elem.InnerText

        '~~> Avg post per day
        elem = GetElementByAttribute("InnerText", "Posts Per Day", "dt", containerElem).NextSibling
        Label7.Text = "Avg Posts Per Day: " & elem.InnerText
    End Sub
End Class
